;include ../LibMain.inc
include CompatLayer.inc

include UndoRedoMgr.inc








.data?
	DefURM dd ?
.code
	
URM_SetDefaultURM proc PUBLIC pURM
	m2m DefURM,pURM
	ret
URM_SetDefaultURM endp

URM_InitHeap proc PUBLIC pHeap
	m2m HEAP1,pHeap
	ret
URM_InitHeap endp



;=====[[ URM_ClearRedoChains >>===\
URM_ClearRedoChains proc PUBLIC UseAll pURM
	local pAction
	
	mov ecx,pURM
	mov DefURM,ecx
	xor edx,edx
	xchg [ecx].UndoRedoMgr.NumRedoGroups,edx
	.while edx
		dec edx
		
		push edx
		
		;--------------[ delete this action chain ]-----------\
		mov ecx,pURM
		mov ecx,[ecx].UndoRedoMgr.RedoGroups[edx*4]
		
		;------[ get first action in chain ]-------\
		.while [ecx].URAction.pPrevAction
			mov ecx,[ecx].URAction.pPrevAction
		.endw
		;------------------------------------------/
				
		;-----[ forward iterate Action chain ]-------------------------------------\
		.while ecx
			push ecx
			invoke [ecx].URAction.pActionFunc,ecx,URM_DISCARD_FROM_REDOBUF,0,0
			pop ecx
			push [ecx].URAction.pNextAction
			free ecx
			pop ecx
		.endw
		;--------------------------------------------------------------------------/
		
			
			
		pop edx
	.endw
	
	
	ret
URM_ClearRedoChains endp
;=======/


;=====<< URM_ClearUndoChains >>===\
URM_ClearUndoChains proc PUBLIC UseAll pURM
	local pAction
	
	mov ecx,pURM
	mov DefURM,ecx
	xor edx,edx
	xchg [ecx].UndoRedoMgr.NumUndoGroups,edx
	.while edx
		dec edx
		
		push edx
		
		;--------------[ delete this action chain ]-----------\
		mov ecx,pURM
		mov ecx,[ecx].UndoRedoMgr.UndoGroups[edx*4]
		
		;------[ get last action in chain ]--------\
		.while [ecx].URAction.pNextAction
			mov ecx,[ecx].URAction.pNextAction
		.endw
		;------------------------------------------/
				
		;-----[ backward iterate+free Action chain ]------------------------------------\
		.while ecx
			push ecx
			invoke [ecx].URAction.pActionFunc,ecx,URM_DISCARD_FROM_UNDOBUF,0,0
			pop ecx
			push [ecx].URAction.pPrevAction
			free ecx
			pop ecx
		.endw
		;-------------------------------------------------------------------------------/
		
		
		pop edx
	.endw
	
	
	ret
URM_ClearUndoChains endp

URM_ClearAll proc PUBLIC pURM
	invoke URM_ClearRedoChains,pURM
	invoke URM_ClearUndoChains,pURM
	
	ret
URM_ClearAll endp

;=======/




;=====<< URM_DeleteOneUndoChain >>===\
URM_DeleteOneUndoChain proc PUBLIC UseAll pURM,pAction
	local pActionFoundIn
	mov ecx,pURM
	mov DefURM,ecx
	
	;-----[ iterate all UndoGroups ]-----------------------------------\
	xor eax,eax
	mov edx,pAction
	mov ebx,[ecx].UndoRedoMgr.NumUndoGroups
	.while eax<ebx
		;------[ try to find EDX in this chain ]-----------\
		
		mov esi,[ecx].UndoRedoMgr.UndoGroups[eax*4]
		mov pActionFoundIn,esi ; just pressume, it's OK
		cmp esi,edx
		je _found ; oh, pAction was a good parameter
		
		;----[ get first member of ESI chain ]----\
		.while [esi].URAction.pPrevAction
			mov esi,[esi].URAction.pPrevAction
		.endw
		;-----------------------------------------/
		;---[ forward iterate ESI chain to search ]--\
		.while esi
			cmp esi,edx
			je _found
			mov esi,[esi].URAction.pNextAction
		.endw
		;--------------------------------------------/
		
		;--------------------------------------------------/ 
		
		inc eax
	.endw
	jmp _ret ; not found
	;------------------------------------------------------------------/
	
	_found:  ; EAX = index
	
	m2m pAction,pActionFoundIn ; because we might've given
				   ; an unsuitable parameter
	
	;------[ unregister from undo chains ]----------------\
	; moves chains backwards to index 0
	dec ebx
	mov [ecx].UndoRedoMgr.NumUndoGroups,ebx
	.while eax<ebx
		mov edx,[ecx].UndoRedoMgr.UndoGroups[eax*4+4]
		mov [ecx].UndoRedoMgr.UndoGroups[eax*4],edx
		inc eax
	.endw
	;-----------------------------------------------------/
	
	;-----[ backward iterate+free Action chain ]-------------------------------\
	mov ecx,pAction
	.while ecx
		push ecx
		invoke [ecx].URAction.pActionFunc,ecx,URM_DISCARD_FROM_UNDOBUF,0,0
		pop ecx
		push [ecx].URAction.pPrevAction
		free ecx
		pop ecx
	.endw
	;--------------------------------------------------------------------------/
	
_ret:	ret
URM_DeleteOneUndoChain endp
;=======/


;=====[[ URM_SetupMenuItems >>===\
URM_SetupMenuItems proc PUBLIC UseAll pURM,hMenu,UndoItemID,RedoItemID,lpszUndoAccel,lpszRedoAccel
	local mi:MENUITEMINFOA
	local _str1[200]:byte
	local str1
	
	lea eax,_str1
	mov str1,eax
	
	
	;----------[ for the Undo item ]-----------------------\
	mov ecx,pURM
	mov mi.cbSize,sizeof MENUITEMINFOA
	mov mi.fMask,MIIM_TYPE or MIIM_STATE	
	mov mi.fType,MFT_STRING
	mov mi.fState,MFS_DISABLED or MFS_GRAYED
	mov mi.dwTypeData,T("Undo")
	.if [ecx].UndoRedoMgr.NumUndoGroups
		invoke strcpy,str1,T("Undo ")
		mov edx,[ecx].UndoRedoMgr.NumUndoGroups
		mov edx,[ecx].UndoRedoMgr.UndoGroups[edx*4-4]
		mov edx,[edx].URAction.lpszDescription
		.if edx
			invoke strcat,str1,edx
		.endif
		.if lpszUndoAccel
			invoke strcat,str1,T("	")
			invoke strcat,str1,lpszUndoAccel
		.endif
		m2m mi.dwTypeData,str1
		mov mi.fState,MFS_ENABLED
	.endif	
	invoke SetMenuItemInfo,hMenu,UndoItemID,0,addr mi
	;------------------------------------------------------/
	
	;----------[ for the Redo item ]-----------------------\
	mov ecx,pURM
	mov mi.cbSize,sizeof MENUITEMINFOA
	mov mi.fMask,MIIM_TYPE or MIIM_STATE	
	mov mi.fType,MFT_STRING
	mov mi.fState,MFS_DISABLED or MFS_GRAYED
	mov mi.dwTypeData,T("Redo")
	.if [ecx].UndoRedoMgr.NumRedoGroups
		invoke strcpy,str1,T("Redo ")
		mov edx,[ecx].UndoRedoMgr.NumRedoGroups
		mov edx,[ecx].UndoRedoMgr.RedoGroups[edx*4-4]
		mov edx,[edx].URAction.lpszDescription
		.if edx
			invoke strcat,str1,edx
		.endif
		.if lpszRedoAccel
			invoke strcat,str1,T("	")
			invoke strcat,str1,lpszRedoAccel
		.endif
		m2m mi.dwTypeData,str1
		mov mi.fState,MFS_ENABLED
	.endif	
	invoke SetMenuItemInfo,hMenu,RedoItemID,0,addr mi
	;------------------------------------------------------/
	
	
	ret
URM_SetupMenuItems endp

URM_CanUndo proc PUBLIC pURM
	mov ecx,pURM
	mov eax,[eax].UndoRedoMgr.NumUndoGroups
	test eax,eax
	ret
URM_CanUndo endp

URM_CanRedo proc PUBLIC pURM
	mov ecx,pURM
	mov eax,[eax].UndoRedoMgr.NumRedoGroups
	test eax,eax
	ret
URM_CanRedo endp
;=======/




;=====<< URM_Compact >>===\
URM_Compact proc PUBLIC UseAll pURM
	mov ecx,pURM
	mov DefURM,ecx
	
	;------[ try to compact the previous undo/redo buff ]-----------------\
	mov eax,[ecx].UndoRedoMgr.NumUndoGroups
	dec eax
	jl _ret
	mov ecx,[ecx].UndoRedoMgr.UndoGroups[eax*4] ; get last undo-chain
	.while [ecx].URAction.pNextAction
		mov ecx,[ecx].URAction.pNextAction
	.endw
	.while ecx
		push ecx
		invoke [ecx].URAction.pActionFunc,ecx,URM_COMPACT,0,0
		pop ecx
		mov ecx,[ecx].URAction.pPrevAction
	.endw
	;---------------------------------------------------------------------/
_ret:	ret
URM_Compact endp
;=======/


;=====<< URM_NewAction >>===\
URM_NewAction proc PUBLIC UseMost pActionFunc,lpszDescription,pData,param1,param2
	local pAction
	
	mov pAction,malloc(URAction)
	
	mov ecx,DefURM
	mov edx,pAction
	assume ecx:ptr UndoRedoMgr
	assume edx:ptr URAction
	
	
	;-----[ are there too many Undo's ? ]--------------------------\
	.if [ecx].NumUndoGroups>=MAX_NUM_UNDOREDO_OPERATIONS
		mov eax,[ecx].UndoGroups[0*4] ; the oldest "undo" chain
		invoke URM_DeleteOneUndoChain,ecx,eax
	.endif
	;--------------------------------------------------------------/
	
	;-----[ try to compact ]-------------\
	.if ![ecx].NumActionsStarted
		invoke URM_Compact,ecx
	.endif
	;------------------------------------/
	
	
	;--------[ link in linked-list ]------------\
	.if [ecx].NumActionsStarted
		mov eax,[ecx].pLastActionStarted
		mov [edx].pPrevAction,eax
		mov [eax].URAction.pNextAction,edx
	.endif
	
	mov [ecx].pLastActionStarted,edx
	inc [ecx].NumActionsStarted
	;-------------------------------------------/
	
	;----[ setup struct ]--------------------\
	m2m [edx].lpszDescription,lpszDescription
	m2m [edx].pActionFunc,pActionFunc
	m2m [edx].pData, pData
	m2m [edx].Param1,param1
	m2m [edx].Param2,param2
	;----------------------------------------/
	
	;------[ send the "action created" msg ]---------------------\
	pushi ecx,edx
	mov ecx,edx
	invoke [edx].pActionFunc,ecx,URM_ACTION_CREATED,pData,param1
	poppi ecx,edx
	;------------------------------------------------------------/
	
	dec [ecx].UndoRedoMgr.NumActionsStarted
	jnz _ret
	
	;--------[ register the UndoGroup[CurUndo] ]------\
	mov edx,[ecx].pLastActionStarted
	mov [ecx].pLastActionStarted,0
	.while [edx].pPrevAction
		mov edx,[edx].pPrevAction
	.endw
	
	mov eax,[ecx].NumUndoGroups
	mov [ecx].UndoGroups[eax*4],edx
	
	inc [ecx].NumUndoGroups
	;-------------------------------------------------/
	
	
	;--------[ delete all RedoGroups ]---------[
	invoke URM_ClearRedoChains,DefURM
	;------------------------------------------/
	
	
	assume edx:nothing
	assume ecx:nothing
_ret:	
	return pAction
URM_NewAction endp
;=======/





;=====<< URM_Undo/Redo >>===\
URM_Undo proc PUBLIC UseAll pURM
	local pAction
	;---------[ get pAction chain end ]------------\
	mov ecx,pURM
	mov eax,[ecx].UndoRedoMgr.NumUndoGroups
	dec eax
	jl _ret
	mov DefURM,ecx
	mov [ecx].UndoRedoMgr.NumUndoGroups,eax
	mov ecx,[ecx].UndoRedoMgr.UndoGroups[eax*4]
	mov pAction,ecx
	
	.while [ecx].URAction.pNextAction
		mov ecx,[ecx].URAction.pNextAction
	.endw
	;----------------------------------------------/
	
	;-----[ backward iterate Action chain ]----------------------------\
	.while ecx
		push ecx
		invoke [ecx].URAction.pActionFunc,ecx,URM_UNDO_ACTION,0,0
		pop ecx
		mov ecx,[ecx].URAction.pPrevAction
	.endw
	;------------------------------------------------------------------/
	
	;----[ move group to RedoGroups ]-----------------\
	mov ecx,pURM
	mov edx,pAction
	mov ebx,[ecx].UndoRedoMgr.NumRedoGroups
	mov [ecx].UndoRedoMgr.RedoGroups[ebx*4],edx
	inc [ecx].UndoRedoMgr.NumRedoGroups
	;-------------------------------------------------/
	
	
_ret:	ret
URM_Undo endp

URM_Redo proc PUBLIC UseAll pURM
	local pAction
	
	;---------[ get pAction chain start ]------------\
	mov ecx,pURM
	mov eax,[ecx].UndoRedoMgr.NumRedoGroups
	dec eax
	jl _ret
	mov DefURM,ecx
	mov [ecx].UndoRedoMgr.NumRedoGroups,eax
	mov ecx,[ecx].UndoRedoMgr.RedoGroups[eax*4]
	mov pAction,ecx
	
	.while [ecx].URAction.pPrevAction
		mov ecx,[ecx].URAction.pPrevAction
	.endw
	;------------------------------------------------/
	
	;-----[ forward iterate Action chain ]----------------------------\
	.while ecx
		push ecx
		invoke [ecx].URAction.pActionFunc,ecx,URM_REDO_ACTION,0,0
		pop ecx
		mov ecx,[ecx].URAction.pNextAction
	.endw
	;-----------------------------------------------------------------/
	
	;----[ move group to UndoGroups ]-----------------\
	mov ecx,pURM
	mov edx,pAction
	mov ebx,[ecx].UndoRedoMgr.NumUndoGroups
	mov [ecx].UndoRedoMgr.UndoGroups[ebx*4],edx
	inc [ecx].UndoRedoMgr.NumUndoGroups
	;-------------------------------------------------/
	
_ret:	ret
URM_Redo endp


URM_CreateURManager proc PUBLIC
	mov eax,malloc(UndoRedoMgr)
	ret
URM_CreateURManager endp

URM_DeleteURManager proc PUBLIC pURM
	invoke URM_ClearAll,pURM
	free pURM
	ret
URM_DeleteURManager endp
;=======/
	

;=====[[ Predefined data-blocks' handlers >>===\

DefAction_Byte proc pAction,msg,param3,param4
	.if msg==URM_ACTION_CREATED
		; mov CACHEDATA <- REALDATA
		mov eax,[ecx].URAction.pData
		mov al,[eax]
		mov [ecx].URAction.Param1,eax
	.elseif msg==URM_UNDO_ACTION || msg==URM_REDO_ACTION
		; exchange CACHEDATA <-> REALDATA
		mov ebx,[ecx].URAction.pData
		mov eax,[ecx].URAction.Param1
		xchg [ebx],al
		mov [ecx].URAction.Param1,eax
	.endif
	ret
DefAction_Byte endp

DefAction_Word proc pAction,msg,param3,param4
	.if msg==URM_ACTION_CREATED
		; mov CACHEDATA <- REALDATA
		mov eax,[ecx].URAction.pData
		mov ax,[eax]
		mov [ecx].URAction.Param1,eax
	.elseif msg==URM_UNDO_ACTION || msg==URM_REDO_ACTION
		; exchange CACHEDATA <-> REALDATA
		mov ebx,[ecx].URAction.pData
		mov eax,[ecx].URAction.Param1
		xchg [ebx],ax
		mov [ecx].URAction.Param1,eax
	.endif
	ret
DefAction_Word endp

DefAction_DWord proc pAction,msg,param3,param4
	.if msg==URM_ACTION_CREATED
		; mov CACHEDATA <- REALDATA
		mov eax,[ecx].URAction.pData
		mov eax,[eax]
		mov [ecx].URAction.Param1,eax
	.elseif msg==URM_UNDO_ACTION || msg==URM_REDO_ACTION
		; exchange CACHEDATA <-> REALDATA
		mov ebx,[ecx].URAction.pData
		mov eax,[ecx].URAction.Param1
		xchg [ebx],eax
		mov [ecx].URAction.Param1,eax
	.endif
	ret
DefAction_DWord endp


DefAction_ConstArray proc pAction,msg,param3,param4
	.if msg==URM_ACTION_CREATED
		; mov CACHEDATA <- REALDATA
		invoke memclone,[ecx].URAction.pData,[ecx].URAction.Param1
		mov [ecx].URAction.Param2,eax
	.elseif msg==URM_UNDO_ACTION || msg==URM_REDO_ACTION
		; exchange CACHEDATA <-> REALDATA
		invoke memclone,[ecx].URAction.pData,[ecx].URAction.Param1  ; TEMP = REALDATA
		invoke memmove,[ecx].URAction.pData,[ecx].URAction.Param2,[ecx].URAction.Param1 ; REALDATA = CACHEDATA
		free [ecx].URAction.Param2 ; FREE(CACHEDATA)
		mov [ecx].URAction.Param2,eax ; CACHEDATA = TEMP		
	.elseif msg==URM_DISCARD_FROM_UNDOBUF || msg==URM_DISCARD_FROM_REDOBUF
		free [ecx].URAction.Param2
	.endif
	ret
DefAction_ConstArray endp


_GetDirtyDataSegment proc uses ebx ecx esi edi pArray1,pArray2,MaxSize ; returns offset start and length in eax:edx
	mov esi,pArray1
	mov edi,pArray2
	
	ret
_GetDirtyDataSegment endp

	
	
memexchange proc uses eax ecx edx esi edi buf1,buf2,bufsize
	mov ecx,bufsize
	cmp ecx,0
	jle _ret
	; btw, funny things happen if the buffers overlap :)
	
	mov esi,buf1
	mov edi,buf2
	shr ecx,2
	jz _bytelevel
	
	align 16
	@@:
		dec ecx
		mov eax,[esi+ecx*4]
		mov edx,[edi+ecx*4]
		mov [esi+ecx*4],edx
		mov [edi+ecx*4],eax
	jnz @B
	mov eax,bufsize
	shr eax,2
	shl eax,2
	add esi,eax
	add edi,eax
	
	
	_bytelevel:
	mov ecx,bufsize
	and ecx,3
	jz _ret
	@@:
		dec ecx
		mov al,[esi+ecx]
		mov dl,[edi+ecx]
		mov [esi+ecx],dl
		mov [edi+ecx],al
	jnz @B 
	
_ret:	ret
memexchange endp


memFindDif proc uses ebx ecx esi edi buf1,buf2,Len ; EAX:EDX = (offset:size)
	local DifStart,DifLen
	mov ecx,Len
	.if !ecx
		_bufIsSame: ; or bad params..
		xor eax,eax
		xor edx,edx
		ret
	.endif
	
	;-------[ forward ]-----------------\
	mov esi,buf1
	mov edi,buf2
	shr ecx,2
	.if !ZERO?
		xor edx,edx
		align 16
		@@:
		mov eax,[esi+edx*4]
		cmp eax,[edi+edx*4]
		jne @F
		inc edx
		cmp edx,ecx
		jl @B
		
		@@:
		shl edx,2
		mov ecx,Len
		add esi,edx
		add edi,edx
		sub ecx,edx
	.endif
	.if ecx
		@@:
		mov al,[esi]
		cmp al,[edi]
		jne @F
		inc esi
		inc edi
		dec ecx
		jnz @B
		@@:
	.endif
	sub esi,buf1
	mov DifStart,esi
	;-----------------------------------/
	;----[ backward ]------------------------------\
	;----[ compute params ]---\
	mov ecx,Len
	sub ecx,DifStart
	jz _bufIsSame
	mov DifLen,ecx
	
	mov esi,buf1
	mov edi,buf2
	add esi,DifStart
	add edi,DifStart
	;-------------------------/
	; we are sure there's a difference, but where?
	; search [DifStart... (Len-1)]
	
	;-----[ byte-based ]----\
	dec ecx
	align 16
	@@:
	mov al,[esi+ecx]
	cmp al,[edi+ecx]
	jne @F
	dec ecx
	jge @B
	@@:
	inc ecx
	;-----------------------/
	
	mov DifLen,ecx
	;----------------------------------------------/
	
	
	mov eax,DifStart
	mov edx,DifLen
	ret
memFindDif endp

memxor proc uses eax ecx esi edi bufOut,bufParam,Len
	mov esi,bufParam
	mov edi,bufOut
	mov ecx,Len
	
	cmp ecx,4
	jl _bytez
	
	shr ecx,2
	align 16
	@@:
		mov eax,[esi+ecx*4-4]
		xor [edi+ecx*4-4],eax
		dec ecx
		jnz @B 
	mov eax,Len
	mov ecx,eax
	shr eax,2
	shl eax,2
	add esi,eax
	add edi,eax
	sub ecx,eax
	
	_bytez:
	cmp ecx,0
	jle _ret
	@@:
		mov al,[esi]
		xor [edi],al
		inc esi
		inc edi
	dec ecx
	jnz @B
	
	
_ret:	ret
memxor endp




	

DefAction_DynArray proc pAction,msg,param3,param4
	local pDirtyData,DirtyDataSize
	local pCacheData,CacheDataSize ; "cloned mem"
	local pBadData,BadDataSize,BadDataOffset
	local CompactCase
	
	
	; Param1 = (bool)IsArrayCompacted
	; Param2 = (char*)pClonedData
	
	
	
	.if msg==URM_ACTION_CREATED
		; clone the memory
		push ecx
		mov eax,[ecx].URAction.pData
		mov eax,[eax]
		.if eax
			invoke HeapSize,HEAP1,0,eax
		.endif
		pop ecx
		
		.if eax
			mov edx,[ecx].URAction.pData
			mov edx,[edx]
			invoke memclone,edx,eax
			mov [ecx].URAction.Param2,eax ; Param2 = cloned memory
		.else
			mov [ecx].URAction.Param2,0
		.endif
	.elseif msg==URM_UNDO_ACTION
		mov eax,[ecx].URAction.Param1
		;---------[ special cases ]-----------------------------\
		cmp eax,1; compacted, same size, having no changes
		je _ret ; really needn't do anything
		
		.if eax==0 ; if not compacted.. yahoo
			; exchange only pointers
			_notCompacted:
			mov edx,[ecx].URAction.pData
			mov eax,[ecx].URAction.Param2
			xchg [edx],eax
			mov [ecx].URAction.Param2,eax
			jmp _ret
		.elseif eax==2 ; compacted, same size, having changes
			;----[ exchange memory of arrays ]---------------------------------\
			mov edx,[ecx].URAction.pData
			mov edx,[edx]
			add edx,[ecx].URAction.Param3
			invoke memexchange,edx,[ecx].URAction.Param2,[ecx].URAction.Param4
			;------------------------------------------------------------------/
			jmp _ret
		.elseif eax==3 ; compacted, same size, compressed XOR'ed
			mov eax,[ecx].URAction.pData
			mov eax,[eax]
			mov pDirtyData,eax
			
			mov pCacheData,malloc([ecx].URAction.Param4)
			invoke unpack,[ecx].URAction.Param2,eax,[ecx].URAction.Param3
			invoke memxor,pDirtyData,pCacheData,[ecx].URAction.Param4
			free pCacheData
		.elseif eax==4 
			mov edx,[ecx].URAction.pData
			invoke memclone,dword ptr[edx],[ecx].URAction.Param3
			xchg [edx],eax
			free eax
			
		.endif
		;-------------------------------------------------------/
		
		
		
		
	.elseif msg==URM_REDO_ACTION
		mov eax,[ecx].URAction.Param1
		cmp eax,1 ; no change in buffer?
		je _ret ; so just return :D
		
		.if eax==0 ; if not compacted.. yahoo
			; exchange only pointers
			mov edx,[ecx].URAction.pData
			mov eax,[ecx].URAction.Param2
			xchg [edx],eax
			mov [ecx].URAction.Param2,eax
			jmp _ret
		.elseif  eax==2 ; compacted, same size, having changes
			;----[ exchange memory of arrays ]---------------------------------\
			mov edx,[ecx].URAction.pData
			mov edx,[edx]
			add edx,[ecx].URAction.Param3
			invoke memexchange,edx,[ecx].URAction.Param2,[ecx].URAction.Param4
			;------------------------------------------------------------------/
			jmp _ret
		.elseif eax==3 ; compacted, same size, compressed XOR'ed
			mov eax,[ecx].URAction.pData
			mov eax,[eax]
			mov pDirtyData,eax
			
			mov pCacheData,malloc([ecx].URAction.Param4)
			invoke unpack,[ecx].URAction.Param2,eax,[ecx].URAction.Param3
			invoke memxor,pDirtyData,pCacheData,[ecx].URAction.Param4
			free pCacheData
		.elseif eax==4
			mov eax,[ecx].URAction.Param3
			add eax,[ecx].URAction.Param4
			mov pCacheData,malloc(eax)
			mov edx,[ecx].URAction.pData
			invoke memmove,eax,dword ptr[edx],[ecx].URAction.Param3
			mov eax,pCacheData
			add eax,[ecx].URAction.Param3
			.if [ecx].URAction.Param5
				invoke unpack,[ecx].URAction.Param2,eax,[ecx].URAction.Param5
			.else
				invoke memmove,eax,[ecx].URAction.Param2,[ecx].URAction.Param4
			.endif
			mov edx,[ecx].URAction.pData
			mov eax,pCacheData
			xchg [edx],eax
			free eax			
		.endif
			
	.elseif msg==URM_DISCARD_FROM_UNDOBUF || msg==URM_DISCARD_FROM_REDOBUF
		free [ecx].URAction.Param2
	.elseif msg==URM_COMPACT && ![ecx].URAction.Param1 ; tricky! Let the fun start ...  >_<
		
		; Param2 = cloned memory
		;---[ get ptr to arrays ]-----\
		mov eax,[ecx].URAction.Param2
		mov pCacheData,eax
		mov eax,[ecx].URAction.pData
		mov eax,[eax]
		mov pDirtyData,eax
		;-----------------------------/
		;-----[ check if they're empty ]-----\
		xor eax,eax
		cmp pCacheData,eax
		je _ret
		cmp pDirtyData,eax
		je _ret
		;------------------------------------/
		
		;----[ get array sizes ]----------\
		invoke HeapSize,HEAP1,0,pCacheData
		cmp eax,100 ; threshold 
		jl _ret
		mov CacheDataSize,eax
		
		invoke HeapSize,HEAP1,0,pDirtyData
		cmp eax,100 ; threshold 
		jl _ret
		mov DirtyDataSize,eax
		;;;cmp eax,CacheDataSize
		;;;jne _ret ; currently don't support array resizing !
		mov CompactCase,0
		;---------------------------------/
		
		
		
		;-----[ find memory difference ]-----------\
		.if eax>CacheDataSize
			mov eax,CacheDataSize
		.endif
		invoke memFindDif,pCacheData,pDirtyData,eax
		mov BadDataOffset,eax
		mov BadDataSize,edx
		;------------------------------------------/
		
		;------[ was the array resized and written to ? ]-------------\
		mov eax,DirtyDataSize
		.if eax==CacheDataSize ; same size, hurray- easy
			; available cases: 1,2,3
			.if BadDataSize
				;--[ !! pBadData is based on pDirtyData ]--\
				mov eax,BadDataOffset
				add eax,pCacheData
				mov pBadData,eax
				;------------------------------------------/
				
				.if BadDataSize<2048 ; case 2
				
					mov ecx,pAction
					;----[ realloc cached data ]----------------------------\
					; we're making the buffer smaller, so:
					.if BadDataOffset
						; shift data left as necessary
						invoke memmove,pCacheData,pBadData,BadDataSize
					.endif
					mov [ecx].URAction.Param2,realloc(pCacheData,BadDataSize)
					;-------------------------------------------------------/
					;-----[ set offset+size ]-------------\
					m2m [ecx].URAction.Param3,BadDataOffset
					m2m [ecx].URAction.Param4,BadDataSize
					;-------------------------------------/
					mov [ecx].URAction.Param1,2 ; mark as compacted, same size, having changes
					jmp _ret
				.else ; BadDataSize>=2048, case 3
					; XOR the array1
					invoke memxor,pCacheData,pDirtyData,CacheDataSize
					; compress the data
					invoke pack,pCacheData,CacheDataSize ; ebx = packed data size
					mov ecx,pAction
					mov [ecx].URAction.Param1,3 ; mark as compacted, same size, compressed XOR
					mov [ecx].URAction.Param2,eax ; pointer to packed data
					mov [ecx].URAction.Param3,ebx ; size of packed data
					m2m [ecx].URAction.Param4,CacheDataSize ; size of unpacked data			
					
					free pCacheData
					
				.endif
				
			.else ; case 1
				
				mov ecx,pAction
				free [ecx].URAction.Param2
				xor eax,eax
				mov [ecx].URAction.Param1,1 ; mark as compacted, same size, having no changes
				mov [ecx].URAction.Param2,eax
				mov [ecx].URAction.Param3,eax
				mov [ecx].URAction.Param4,eax
				jmp _ret
			.endif
		
		.elseif eax>CacheDataSize ; Array2>Array1
			; cases 4,5
			mov eax,DirtyDataSize
			sub eax,CacheDataSize
			mov edx,pDirtyData
			add edx,CacheDataSize
			
			.if BadDataSize ; case 5
				
			.else ; case 4 - the only change is the resizing of the array
				push eax ; size of the extra bytes
				.if eax<2048
					invoke memmove,pCacheData,edx,eax
					mov eax,realloc(pCacheData,eax)
					xor ebx,ebx
				.else
					; extra compression
					invoke pack,edx,eax
				.endif
				
				mov ecx,pAction
				mov [ecx].URAction.Param1,4 ; mark as compacted, grown, no common change
				mov [ecx].URAction.Param2,eax
				m2m [ecx].URAction.Param3,CacheDataSize
				pop [ecx].URAction.Param4 ; size of unpacked data
				mov [ecx].URAction.Param5,ebx ; size of packed data
				
				.if ebx ; if was packed
					free pCacheData
				.endif
				
			.endif	
			jmp  _ret		
		.else		  ; Array1<Array2
			
		.endif
		
		;-------------------------------------------------------------/
		
	.endif
	
	
_ret:	ret
DefAction_DynArray endp


ifndef NO_OBJVECTORS
DefAction_ObjVector_Insert proc pAction,msg,param3,param4
	.if msg==URM_ACTION_CREATED
		icall [ecx].URAction.pData,ObjVector,insertSafely,[ecx].URAction.Param1
	.elseif msg==URM_UNDO_ACTION
		icall [ecx].URAction.pData,ObjVector,deleteSafely,[ecx].URAction.Param1
	.elseif msg==URM_REDO_ACTION
		icall [ecx].URAction.pData,ObjVector,insertSafely,[ecx].URAction.Param1
	;.elseif msg==URM_DISCARD_FROM_UNDOBUF  ; nothing to do here, actually
	;.elseif msg==URM_DISCARD_FROM_REDOBUF  ; nothing to do here, actually		
	.endif
	
	ret
DefAction_ObjVector_Insert endp	


DefAction_ObjVector_Delete proc pAction,msg,param3,param4
	.if msg==URM_ACTION_CREATED
		icall [ecx].URAction.pData,ObjVector,deleteSafely,[ecx].URAction.Param1
	.elseif msg==URM_UNDO_ACTION
		icall [ecx].URAction.pData,ObjVector,insertSafely,[ecx].URAction.Param1
	.elseif msg==URM_REDO_ACTION
		icall [ecx].URAction.pData,ObjVector,deleteSafely,[ecx].URAction.Param1
	;.elseif msg==URM_DISCARD_FROM_UNDOBUF  ; nothing to do here, actually
	;.elseif msg==URM_DISCARD_FROM_REDOBUF  ; nothing to do here, actually		
	.endif
	
	ret
DefAction_ObjVector_Delete endp	
endif
;=======/



XURM_Word proc PUBLIC pWord
	invoke URM_NewAction,DefAction_Word,0,pWord,0,0
	ret
XURM_Word endp



XURM_Dword proc PUBLIC pDword
	invoke URM_NewAction,DefAction_DWord,0,pDword,0,0
	ret
XURM_Dword endp

XURM_ConstArray proc PUBLIC pArray,ArraySize
	invoke URM_NewAction,DefAction_ConstArray,0,pArray,ArraySize,0
	ret
XURM_ConstArray endp

XURM_DynArray proc PUBLIC ppvArray  ; pointer to pointer.  This array MUST be allocated with HEAP1
	invoke URM_NewAction,DefAction_DynArray,0,ppvArray,0,0
	ret
XURM_DynArray endp

ifndef NO_OBJVECTORS
XURM_ObjVector_Insert proc PUBLIC pObjVector,ObjPtr
	invoke URM_NewAction,DefAction_ObjVector_Insert,0,pObjVector,ObjPtr,0
	ret
XURM_ObjVector_Insert endp

XURM_ObjVector_Delete proc PUBLIC pObjVector,ObjPtr	; this is a simple delete, doesn't take into account the old ObjPtr's position in the ObjVector buffer!!
	invoke URM_NewAction,DefAction_ObjVector_Delete,0,pObjVector,ObjPtr,0
	ret
XURM_ObjVector_Delete endp
endif


end


;=====================================================================================================================
;=====================================================================================================================
;=====================================================================================================================
;=====================================================================================================================
;=====================================================================================================================

;-----------------------------------------------------------------\
;		 	<< Example start >>
;-----------------------------------------------------------------/

.data
	uMgr1 dd 0
	
	baka dd 7
	baka2 dd 10
	
	str1 db 32 dup (0)
	
	pStr2 dd 0
	
	
.code
	
printStuff proc
	trace "%d , %d , %s,  %s",baka,baka2,addr str1,pStr2
	ret
printStuff endp



MyObjectUndoRedoProc proc pAction,msg,param1,param2
	mov ecx,pAction
	xor eax,eax  ; must do!
	.if msg==URM_ACTION_CREATED
		invoke XURM_Dword,addr baka
		invoke XURM_Dword,addr baka2
		invoke XURM_ConstArray,addr str1,32
		invoke XURM_DynArray,addr pStr2
	.endif
	ret
MyObjectUndoRedoProc endp


main proc
	invoke URM_CreateURManager
	mov uMgr1,eax
	
	
	invoke strcpy,addr str1,T("<initial string>")
	
	
	invoke URM_SetDefaultURM,uMgr1
	invoke URM_NewAction,MyObjectUndoRedoProc,T("Dirty some globals"),0,0,0
	
	invoke printStuff  ; we haven't modified anything yet
	
	;-----[ let's dirty some data ]------------------\
	mov baka,60
	invoke strcpy,addr str1,T("!DirtyString!")
	invoke CloneString,T("this is a dynamic string")
	mov pStr2,eax
	;------------------------------------------------/
	
	
	invoke printStuff ; show how 'dirty' our data is
	
	; let's undo once
	invoke URM_Undo,uMgr1
	
	
	invoke printStuff ; see, our data is clean again :)
	
	
	; but we don't like our data, so we'll Redo
	invoke URM_Redo,uMgr1
	
	
	invoke printStuff ; yup,we like the data dirty
	
	
	ret
main endp


start:
call main
invoke ExitProcess,0

end start
