MAX_NUM_UNDOREDO_OPERATIONS equ 300 ; can easily set to 1000 or more




URM_ACTION_CREATED		equ 0	; called only once, when the action is created. _Here_ create more actions
URM_UNDO_ACTION			equ 1	; undo the action
URM_REDO_ACTION			equ 2	; redo the action
URM_DISCARD_FROM_UNDOBUF	equ 3	; stop managing this object/action
URM_DISCARD_FROM_REDOBUF	equ 4	; completely destroy object/action
URM_COMPACT			equ 5	; try to compress the data, comparing with the current data

URAction struct
	pNextAction	dd ?
	pPrevAction	dd ?
	
	pActionFunc	IFUNC(pAction,msg,param3,param4)
	lpszDescription	dd ?
	
	pData		dd ?
	Param1		dd ?
	Param2		dd ?
	
	Param3		dd ?
	Param4		dd ?
	Param5		dd ?
URAction ends



UndoRedoMgr struct
	NumUndoGroups	dd ?
	NumRedoGroups	dd ?
	
	
	NumActionsStarted	dd ?
	pLastActionStarted	dd ?
	
	
	UndoGroups	dd MAX_NUM_UNDOREDO_OPERATIONS dup (?)
	RedoGroups	dd MAX_NUM_UNDOREDO_OPERATIONS dup (?)
	
UndoRedoMgr ends



;-------------[ Undo/Redo Manager ]-------------------------------------------------------------------------------------------------------\
URM_InitHeap			proto pHeap:DWORD
URM_SetDefaultURM		proto pURM:DWORD
URM_ClearRedoChains		proto pURM:DWORD
URM_ClearUndoChains		proto pURM:DWORD
URM_ClearAll			proto pURM:DWORD
URM_DeleteOneUndoChain		proto pURM:DWORD,pAction:DWORD
URM_NewAction			proto pActionFunc:DWORD,lpszDescription:DWORD,pData:DWORD,param1:DWORD,param2:DWORD
URM_Undo			proto pURM:DWORD
URM_Redo			proto pURM:DWORD
URM_CreateURManager		proto
URM_DeleteURManager		proto pURM:DWORD
URM_SetupMenuItems		proto pURM:DWORD,hMenu:DWORD,UndoItemID:DWORD,RedoItemID:DWORD,lpszUndoAccel:DWORD,lpszRedoAccel:DWORD
URM_CanUndo			proto pURM:DWORD
URM_CanRedo			proto pURM:DWORD

XURM_Word			proto pWord:DWORD
XURM_Dword			proto pDword:DWORD
XURM_ConstArray			proto pArray:DWORD,ArraySize:DWORD
XURM_DynArray			proto ppvArray:DWORD  ; pointer to pointer.  This array MUST be allocated with HEAP1
XURM_ObjVector_Insert		proto pObjVector:DWORD,ObjPtr:DWORD
XURM_ObjVector_Delete		proto pObjVector:DWORD,ObjPtr:DWORD ; this is a simple delete, doesn't take into account the old
;----------------------------------------------------------------------------------------------------------------------------------------/
